

//Программа для управления LED кубом 5*5*5 на "умных светодиодах" WS2812B,PL9823
// Подключаем библиотеку Adafruit NeoPixel.
#include "Adafruit_NeoPixel.h"

// Указываем, какое количество пикселей у нашей ленты - куба
#define LED_COUNT1 125


// Указываем, к какому порту подключен вход ленты DIN.
#define LED_PIN1 6

Adafruit_NeoPixel strip1 = Adafruit_NeoPixel(LED_COUNT1, LED_PIN1, NEO_GRB + NEO_KHZ400);// Создаем переменную strip для управления нашей лентой. 
 int N=0;//Переменная номера программы переключений
 int d=0;int d1=200;long y1=0;long y2=0;long Y1=0;long Y2=0;long Y3=0;long Y4=0;
 int x=0;int y=0;int z=0; int x0=0; int x1=0;
 int r=0;int g=0;int b=0;
 int k=50;//Переменная задающая яркость свечения пикселя из 0 до 255 ступеней
 int j=0;int i=0;// Счётчики для циклов
 int k1=5;//Переменная задающая число пикселей в ребре куба
 int n=35;//переменная задающая длительность переключений
 int r1;int j1=0;
 int l=0;int l1=0;int y5=0;int v=1;
 
void setup()
{
 // Инициализация ленты
 strip1.begin();
 strip1.show();
 
 pinMode (7,INPUT );// подключение микрофона - акустического датчика 
 pinMode(A0, INPUT); // подключение регулятора динамики анимации
 pinMode(A1, INPUT); // подключение регулятора яркости
 }
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void loop()
{
 //Условие возращения к автоматическому перебору программ спустя не ранее 60 сек после последнего акустического сигнала
  Y3=millis ();if (Y3-Y4>=60000){N=0;}
 
//////////////////////////////////////////////////  ПРОГРАММА РАДУЖНЫЙ ДОЖДИК N=1 /////////////////////////////////////////////////////// 
//Условия числа повторов программы со случайным выбором цвета свечения
while (d<6){
 g=random(0,2);r=0;b=random(0,2); 
 if (g==0&&b==0){g=1;}
 if (g==1&&b==1){g=0;}
 
  // Условие исполнения данного фрагмента-программы переключений///////////////////////
 if(N!=1&&N!=0){goto metka1;}//////////////////////////////////////////////////////////
 
 // Циклы переключения пикселей
  for (i = 0; i <= k1-1; i++)
  {
    for(j=0;j<=k1*k1-1;j++)
    {
  strip1.setPixelColor(i+k1*j, strip1.Color(k*g,k*r,k*b)); //псевдослучайный цвет на яркости k
    } 
  strip1.show();
 
if(N!=1&&N!=0){goto metka1;}

  fun (2*n);///////////////////   ФУНКЦИЯ   ///////////////////
  
  if (i<=k1-2){
    for(j=0;j<=k1*k1-1;j++)
    { 
  strip1.setPixelColor(i+k1*j, strip1.Color(0,0,0));//выключение пикселя
    }
   strip1.show();}
  }
   
   for (i=k1*k1*k1-1 ; i >= 0; i--)
  {
  strip1.setPixelColor(i, strip1.Color(k*g,k*r,k*b)); //псевдослучайный цвет
 strip1.show();
 if(N!=1&&N!=0){goto metka1;}
 fun (n);///////////////////   ФУНКЦИЯ   /////////////////// 
  strip1.setPixelColor(i, strip1.Color(0,0,0)); //выключение пикселя
  strip1.show();
  }d++;} metka1:
  j1=0; d=0;
 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
 ////////////////////////////////// ПРОГРАММА ПИКСЕЛЬНЫЙ АССОРТИ N=2//////////////////////////////////////////
 while (d<4){
 int tabl1[3]={0,5,50};j1=tabl1[random(0,3)];// Условие,задающее смену количества одновременно светящихся пикселей
 if(j1==50){d1=50;}else{d1=200;}
for(r1=0;r1<=d1;r1++)
{
  g=random(0,2);r=random(0,2);b=random(0,2); //псевдослучайный выбор цвета с исключением его отсутствия
  if (g==0&&r==0&&b==0){r=1;g=1;}
 x=random(0,5);y=random(0,5);z=random(0,5);
  strip1.setPixelColor(x+k1*y+k1*k1*z, strip1.Color(k*g,k*r,k*b)); //псевдослучайный цвет на яркости k
 strip1.show();
 if(N!=2&&N!=0){goto metka2;}
  fun (n);///////////////////   ФУНКЦИЯ   ///////////////////
  for(i=0;i<=j1;i++)
  {
  x=random(0,5);y=random(0,5);z=random(0,5);
  strip1.setPixelColor(x+k1*y+k1*k1*z, strip1.Color(0,0,0)); //псевдослучайное выключение пикселей
  strip1.show(); 
  } 
  }d++;}metka2:d=0;k1=6;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
 ////////////////////////////////// ПРОГРАММА ПЕРЕКЛЮЧЕНИЯ РАДУЖНОЕ СИЯНИЕ N=3 //////////////////////////////////////////
 while(d<35){
 g=random(0,2);r=random(0,2);b=random(0,2); //псевдослучайный выбор цвета с исключением его отсутствия
if (g==0&&r==0&&b==0){r=1;g=1;}
 y1=millis();if(y1-y2>=150*n){y5=!y5;y2=y1;}//условие смены переключения с одновременно одноцветного на двухцветное
 if(N!=3&&N!=0){goto metka3;}
  // Включаем и выключаем по одной плоскости в одну сторону по диагонали светодиоды.
  for (i = 0; i <= k1-1; i++)
  {
    for(j=0;j<=k1*k1-1;j++)
    {
  strip1.setPixelColor(i+k1*j, strip1.Color(k*g,k*r,k*b)); //псевдослучайный цвет на яркости k
    } 
  strip1.show();
  if(N!=3&&N!=0){goto metka3;}
fun (3*n);///////////////////   ФУНКЦИЯ   ///////////////////  
  if (i<=k1-2*y5){
    for(j=0;j<=k1*k1-1;j++)
    { 
  strip1.setPixelColor(i+k1*j, strip1.Color(0,0,0));//выключение пикселя
    }
   strip1.show();}
  }d++;}metka3:d=0;k1=5;j=0;
   
 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
  ////////////////////////////////// ПРОГРАММА ПРЫГАЮЩАЯ ЗВЕЗДА N=4//////////////////////////////////////////
  for (i=0;i<=k1*k1*k1-1;i++)
{
 strip1.setPixelColor(i, strip1.Color(0,0,0)); 
}
 strip1.show();
 while (d<30){
  g=random(0,2);r=random(0,2);b=random(0,2); //псевдослучайный выбор цвета с исключением его отсутствия
  if (g==0&&r==0&&b==0){r=1;g=1;}
  if(N!=4&&N!=0){goto metka4;}
 x=random(0,3);y=random(0,3);z=random(0,3);
  strip1.setPixelColor((x+1)+k1*(y)+k1*k1*(z+1), strip1.Color(k*g,k*r,k*b)); //псевдослучайный цвет на яркости k
   strip1.setPixelColor((x+1)+k1*(y+1)+k1*k1*(z+1), strip1.Color(k*g,k*r,k*b));
    strip1.setPixelColor((x+1)+k1*(y+2)+k1*k1*(z+1), strip1.Color(k*g,k*r,k*b));
     strip1.setPixelColor((x)+k1*(y+1)+k1*k1*(z+1), strip1.Color(k*g,k*r,k*b));
      strip1.setPixelColor((x+2)+k1*(y+1)+k1*k1*(z+1), strip1.Color(k*g,k*r,k*b));
       strip1.setPixelColor((x+1)+k1*(y+1)+k1*k1*(z), strip1.Color(k*g,k*r,k*b));
        strip1.setPixelColor((x+1)+k1*(y+1)+k1*k1*(z+2), strip1.Color(k*g,k*r,k*b));
strip1.show();

fun (5*n);///////////////////   ФУНКЦИЯ   ///////////////////

 
   strip1.setPixelColor((x+1)+k1*(y)+k1*k1*(z+1), strip1.Color(0,0,0)); 
   strip1.setPixelColor((x+1)+k1*(y+1)+k1*k1*(z+1), strip1.Color(0,0,0));
    strip1.setPixelColor((x+1)+k1*(y+2)+k1*k1*(z+1), strip1.Color(0,0,0));
     strip1.setPixelColor((x)+k1*(y+1)+k1*k1*(z+1), strip1.Color(0,0,0));
      strip1.setPixelColor((x+2)+k1*(y+1)+k1*k1*(z+1), strip1.Color(0,0,0));
       strip1.setPixelColor((x+1)+k1*(y+1)+k1*k1*(z), strip1.Color(0,0,0));
        strip1.setPixelColor((x+1)+k1*(y+1)+k1*k1*(z+2), strip1.Color(0,0,0));// выключение пикселей
  strip1.show();
d++;}metka4:d=0;
 
//////////////////////////////////////////ПРОГРАММА ВРАЩЕНИЕ ПЛОСКОСТИ N=5 /////////////////////////////////////////////////////////
while(d<50){
g=random(0,2);r=random(0,2);b=random(0,2); //псевдослучайный выбор цвета с исключением его отсутствия
  if (g==0&&r==0&&b==0){r=1;g=1;}

//////////////////////////////////////////////////////////////////////////////////////////////////////
if(N!=5&&N!=0){goto metka5;}////////////////////////////////////////////////////////////////////////
for (x=0;x<=4;x++)
{
  
 for (y=0;y<=4;y++)
{
 
  int tabl2[48]={x,y,2, x,y,y, x,2,y, x,4-y,y,  x,y,2, y,x,y, 2,x,y, 4-y,x,y, x,y,2, x,y,y, x,2,y, y,4-y,x, 2,x,y, 4-y,4-y,x, x,2,y, x,y,y  };
  strip1.setPixelColor(tabl2[j]+k1*tabl2[j+1]+k1*k1*tabl2[j+2], strip1.Color(k*g,k*r,k*b));
  

}
}
strip1.show(); 
if(N!=5&&N!=0){goto metka5;}
fun (4*n);///////////////////   ФУНКЦИЯ   ///////////////////
 j=j+3;if(j>47){j=0;}
//////////////////////////////////////////////////////////////////////////////////////////////////////////      
for (i=0;i<=k1*k1*k1-1;i++)
{
 strip1.setPixelColor(i, strip1.Color(0,0,0)); 
}
 strip1.show();
d++;}metka5:d=0;
//////////////////////////////////////////////////  ПРОГРАММА ПОЛЁТ ПЛОСКОСТИ N=6 /////////////////////////////////////////////////////// 
while (d<10){
 g=random(0,2);r=random(0,2);b=random(0,2); 
 if (g==0&&r==0&&b==0){r=1;g=1;}
 
  
 if(N!=6&&N!=0){goto metka7;}//////////////////////////////////////////////////////////
 int tablA[15]={0,1,2,3,4,4,4,4,3,2,1,0,0,0};
 int tablB[15]={0,0,1,2,3,4,4,4,4,3,2,1,0,0};
 int tablC[15]={0,0,0,1,2,3,4,4,4,4,3,2,1,0};
 int tablD[15]={0,0,0,0,1,2,3,4,4,4,4,3,2,1};
  for (i = 0; i <=14; i++)
  {
   
  strip1.setPixelColor((tablA[i])+k1*(2)+k1*k1*(2), strip1.Color(k*g,k*r,k*b)); //псевдослучайный цвет на яркости k
  
   strip1.setPixelColor((tablB[i])+k1*(2)+k1*k1*(1), strip1.Color(k*g,k*r,k*b));
   strip1.setPixelColor((tablB[i])+k1*(2)+k1*k1*(3), strip1.Color(k*g,k*r,k*b)); 
   strip1.setPixelColor((tablB[i])+k1*(1)+k1*k1*(2), strip1.Color(k*g,k*r,k*b));
   strip1.setPixelColor((tablB[i])+k1*(3)+k1*k1*(2), strip1.Color(k*g,k*r,k*b));

    strip1.setPixelColor((tablC[i])+k1*(0)+k1*k1*(2), strip1.Color(k*g,k*r,k*b));
   strip1.setPixelColor((tablC[i])+k1*(4)+k1*k1*(2), strip1.Color(k*g,k*r,k*b)); 
   strip1.setPixelColor((tablC[i])+k1*(2)+k1*k1*(0), strip1.Color(k*g,k*r,k*b));
   strip1.setPixelColor((tablC[i])+k1*(2)+k1*k1*(4), strip1.Color(k*g,k*r,k*b));
    strip1.setPixelColor((tablC[i])+k1*(1)+k1*k1*(1), strip1.Color(k*g,k*r,k*b));
   strip1.setPixelColor((tablC[i])+k1*(3)+k1*k1*(1), strip1.Color(k*g,k*r,k*b)); 
   strip1.setPixelColor((tablC[i])+k1*(1)+k1*k1*(3), strip1.Color(k*g,k*r,k*b));
   strip1.setPixelColor((tablC[i])+k1*(3)+k1*k1*(3), strip1.Color(k*g,k*r,k*b));

    strip1.setPixelColor((tablD[i])+k1*(1)+k1*k1*(0), strip1.Color(k*g,k*r,k*b));
   strip1.setPixelColor((tablD[i])+k1*(0)+k1*k1*(1), strip1.Color(k*g,k*r,k*b)); 
   strip1.setPixelColor((tablD[i])+k1*(3)+k1*k1*(0), strip1.Color(k*g,k*r,k*b));
   strip1.setPixelColor((tablD[i])+k1*(4)+k1*k1*(1), strip1.Color(k*g,k*r,k*b));
    strip1.setPixelColor((tablD[i])+k1*(0)+k1*k1*(3), strip1.Color(k*g,k*r,k*b));
   strip1.setPixelColor((tablD[i])+k1*(1)+k1*k1*(4), strip1.Color(k*g,k*r,k*b)); 
   strip1.setPixelColor((tablD[i])+k1*(3)+k1*k1*(4), strip1.Color(k*g,k*r,k*b));
   strip1.setPixelColor((tablD[i])+k1*(4)+k1*k1*(3), strip1.Color(k*g,k*r,k*b));
   
  strip1.show();
  fun (3*n);///////////////////   ФУНКЦИЯ   ///////////////////
  strip1.setPixelColor((tablA[i])+k1*(2)+k1*k1*(2), strip1.Color(0,0,0)); 
  
  strip1.setPixelColor((tablB[i])+k1*(2)+k1*k1*(1), strip1.Color(0,0,0)); 
  strip1.setPixelColor((tablB[i])+k1*(2)+k1*k1*(3), strip1.Color(0,0,0));
  strip1.setPixelColor((tablB[i])+k1*(1)+k1*k1*(2), strip1.Color(0,0,0));
  strip1.setPixelColor((tablB[i])+k1*(3)+k1*k1*(2), strip1.Color(0,0,0));

  strip1.setPixelColor((tablC[i])+k1*(0)+k1*k1*(2), strip1.Color(0,0,0));
   strip1.setPixelColor((tablC[i])+k1*(4)+k1*k1*(2), strip1.Color(0,0,0)); 
   strip1.setPixelColor((tablC[i])+k1*(2)+k1*k1*(0), strip1.Color(0,0,0));
   strip1.setPixelColor((tablC[i])+k1*(2)+k1*k1*(4), strip1.Color(0,0,0));
    strip1.setPixelColor((tablC[i])+k1*(1)+k1*k1*(1), strip1.Color(0,0,0));
   strip1.setPixelColor((tablC[i])+k1*(3)+k1*k1*(1), strip1.Color(0,0,0)); 
   strip1.setPixelColor((tablC[i])+k1*(1)+k1*k1*(3), strip1.Color(0,0,0));
   strip1.setPixelColor((tablC[i])+k1*(3)+k1*k1*(3), strip1.Color(0,0,0));

    strip1.setPixelColor((tablD[i])+k1*(1)+k1*k1*(0), strip1.Color(0,0,0));
   strip1.setPixelColor((tablD[i])+k1*(0)+k1*k1*(1), strip1.Color(0,0,0)); 
   strip1.setPixelColor((tablD[i])+k1*(3)+k1*k1*(0), strip1.Color(0,0,0));
   strip1.setPixelColor((tablD[i])+k1*(4)+k1*k1*(1), strip1.Color(0,0,0));
    strip1.setPixelColor((tablD[i])+k1*(0)+k1*k1*(3), strip1.Color(0,0,0));
   strip1.setPixelColor((tablD[i])+k1*(1)+k1*k1*(4), strip1.Color(0,0,0)); 
   strip1.setPixelColor((tablD[i])+k1*(3)+k1*k1*(4), strip1.Color(0,0,0));
   strip1.setPixelColor((tablD[i])+k1*(4)+k1*k1*(3), strip1.Color(0,0,0));
  
  strip1.show();
  }d++;} metka7:
   d=0;
 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//////////////////////////////////////////////////  ПРОГРАММА САЛЮТ N=7 /////////////////////////////////////////////////////// 
while (d<10){
 g=random(0,2);r=random(0,2);b=random(0,2); 
 if (g==0&&r==0&&b==0){r=1;g=1;}
 
  
 if(N!=7&&N!=0){goto metka8;}//////////////////////////////////////////////////////////

  for (i = 0; i <=4; i++)
  {
  strip1.setPixelColor((i)+k1*(i)+k1*k1*(i), strip1.Color(k*g,k*r,k*b)); //псевдослучайный цвет на яркости k
  strip1.show();
  fun (3*n);///////////////////   ФУНКЦИЯ   ///////////////////
  strip1.setPixelColor((i)+k1*(i)+k1*k1*(i), strip1.Color(0,0,0));
  strip1.show();
  }

  g=random(0,2);r=random(0,2);b=random(0,2); 
 if (g==0&&r==0&&b==0){r=1;g=1;}
   for (i = 3; i>=0; i--)
  {
 
  
  strip1.setPixelColor((4)+k1*(4)+k1*k1*(i), strip1.Color(k*g,k*r,k*b)); //псевдослучайный цвет на яркости k
  strip1.setPixelColor((i)+k1*(4)+k1*k1*(i), strip1.Color(k*g,k*r,k*b));
  strip1.setPixelColor((i)+k1*(4)+k1*k1*(4), strip1.Color(k*g,k*r,k*b));
  strip1.setPixelColor((i)+k1*(i)+k1*k1*(4), strip1.Color(k*g,k*r,k*b));
  strip1.setPixelColor((4)+k1*(i)+k1*k1*(4), strip1.Color(k*g,k*r,k*b));
  strip1.setPixelColor((4)+k1*(i)+k1*k1*(i), strip1.Color(k*g,k*r,k*b));
  strip1.show();
  fun (2*n);///////////////////   ФУНКЦИЯ   ///////////////////
   }
    for (i = 3; i>=1; i--)
  {
 
  strip1.setPixelColor((4)+k1*(4)+k1*k1*(i), strip1.Color(0,0,0)); //псевдослучайный цвет на яркости k
  strip1.setPixelColor((i)+k1*(4)+k1*k1*(i), strip1.Color(0,0,0));
  strip1.setPixelColor((i)+k1*(4)+k1*k1*(4), strip1.Color(0,0,0));
  strip1.setPixelColor((i)+k1*(i)+k1*k1*(4), strip1.Color(0,0,0));
  strip1.setPixelColor((4)+k1*(i)+k1*k1*(4), strip1.Color(0,0,0));
  strip1.setPixelColor((4)+k1*(i)+k1*k1*(i), strip1.Color(0,0,0));
  strip1.show();
  fun (2*n);///////////////////   ФУНКЦИЯ   ///////////////////
   }
    for (i = 4; i>=0; i--)
  {
  strip1.setPixelColor((i)+k1*(4)+k1*k1*(0), strip1.Color(k*g,k*r,k*b)); //псевдослучайный цвет на яркости k
  strip1.setPixelColor((i)+k1*(0)+k1*k1*(0), strip1.Color(k*g,k*r,k*b));
  strip1.setPixelColor((i)+k1*(0)+k1*k1*(4), strip1.Color(k*g,k*r,k*b));
  strip1.show();
  fun (5*n);///////////////////   ФУНКЦИЯ   ///////////////////
  strip1.setPixelColor((i)+k1*(4)+k1*k1*(0), strip1.Color(0,0,0)); //псевдослучайный цвет на яркости k
  strip1.setPixelColor((i)+k1*(0)+k1*k1*(0), strip1.Color(0,0,0));
  strip1.setPixelColor((i)+k1*(0)+k1*k1*(4), strip1.Color(0,0,0));
  strip1.setPixelColor((i)+k1*(4)+k1*k1*(4), strip1.Color(0,0,0));
  strip1.show();
   }
  d++;} metka8:
  j1=0; d=0;
 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//////////////////////////////////////////////////  ПРОГРАММА ВОЛНА N=8 /////////////////////////////////////////////////////// 
while (d<7){
 
 
 
 if(N!=8&&N!=0){goto metka9;}//////////////////////////////////////////////////////////
  
  for (j = 1; j <=4; j++)
  {
    g=random(0,2);r=random(0,2);b=random(0,2); 
    if (g==0&&r==0&&b==0){r=1;g=1;}
  for (x = 0; x <=j; x++)
  {
  for (y = 0; y <=j; y++)
  {
  for (z = 0; z <=j; z++)
  {
  strip1.setPixelColor((x)+k1*(y)+k1*k1*(z), strip1.Color(k*g,k*r,k*b)); //псевдослучайный цвет на яркости k
  }
  }
  }
  for (x = 0; x <=j-1; x++)
  {
  for (y = 0; y <=j-1; y++)
  {
  for (z = 0; z <=j-1; z++)
  {
  strip1.setPixelColor((x)+k1*(y)+k1*k1*(z), strip1.Color(0,0,0)); //псевдослучайный цвет на яркости k
  }
  }
  }
  strip1.show();
  fun (5*n);///////////////////   ФУНКЦИЯ   ///////////////////
  for (i = 0; i <=124; i++)
  {strip1.setPixelColor(i, strip1.Color(0,0,0));}
  }
  ////////////////////////////////////////////////////////////////////////////////////////////////////////
   for (j = 4; j >=1; j--)
  {
    g=random(0,2);r=random(0,2);b=random(0,2); 
    if (g==0&&r==0&&b==0){r=1;g=1;}
  for (x = j; x >=0; x--)
  {
  for (y = j; y >=0; y--)
  {
  for (z = j; z >=0; z--)
  {
  strip1.setPixelColor((x)+k1*(y)+k1*k1*(z), strip1.Color(k*g,k*r,k*b)); //псевдослучайный цвет на яркости k
  }
  }
  }
  for (x = j-1; x >=0; x--)
  {
  for (y = j-1; y >=0; y--)
  {
  for (z = j-1; z >=0; z--)
  {
  strip1.setPixelColor((x)+k1*(y)+k1*k1*(z), strip1.Color(0,0,0)); //псевдослучайный цвет на яркости k
  }
  }
  }
  strip1.show();
  fun (5*n);///////////////////   ФУНКЦИЯ   ///////////////////
  for (i = 0; i <=124; i++)
  {strip1.setPixelColor(i, strip1.Color(0,0,0));} strip1.show();
  }
  d++;} metka9:
  j=0; d=0;
 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 

 //////////////////////////////////////////////////  ПРОГРАММА ЦВЕТОВОЙ ПЕРЕХОД N=9 /////////////////////////////////////////////////////// 
//Условие числа повторов программы 
while (d<3){

 
  // Условие исполнения данного фрагмента-программы переключений///////////////////////
 if(N!=9&&N!=0){goto metka10;}//////////////////////////////////////////////////////////
 r=1;g=1;b=1;
 // Циклы переключения пикселей
  for (i = 0; i <=9; i++)
  {
    for(j=0;j<=124;j=j+2)
    {
  strip1.setPixelColor(j, strip1.Color((k/9)*i*g,(k-(k/9)*i)*r,0));
  strip1.setPixelColor(j+1, strip1.Color(0,0,0));
    } 
  strip1.show();
  fun (10*n);///////////////////   ФУНКЦИЯ   ///////////////////
   for(j=0;j<=124;j=j+2)
    {
  strip1.setPixelColor(j+1, strip1.Color((k/9)*i*g,0,(k-(k/9)*i)*b));
  strip1.setPixelColor(j, strip1.Color(0,0,0));
    } 
  strip1.show();
  fun (10*n);///////////////////   ФУНКЦИЯ   ///////////////////
  }
  ////////////////////////////////////////////////////////////////////////////////////////////
  // Циклы переключения пикселей
  for (i = 0; i <=9; i++)
  {
    for(j=0;j<=124;j=j+2)
    {
  strip1.setPixelColor(j, strip1.Color(0,(k-(k/9)*i)*r,(k/9)*i*b));
  strip1.setPixelColor(j+1, strip1.Color(0,0,0));
    } 
  strip1.show();
  fun (10*n);///////////////////   ФУНКЦИЯ   ///////////////////
   for(j=0;j<=124;j=j+2)
    {
  strip1.setPixelColor(j+1, strip1.Color((k-(k/9)*i)*g,0,(k/9)*i*b));
  strip1.setPixelColor(j, strip1.Color(0,0,0));
    } 
  strip1.show();
  fun (10*n);///////////////////   ФУНКЦИЯ   ///////////////////
  }
  d++;} metka10:
  d=0;
 /////////////////////////////////////////////////////////////////////////////////////////////


 

 
}
////////////////////////////////////////   ФУНКЦИИ ОПИСАНИЕ   //////////////////////////////////////////////////////
//Функция земеняет выполнение команды delay(T1); в ней на время паузы статичного свечения пикселей идёт опрос датчиков
// По результату опроса задаётся номер программы для ближайшего исполнения, скорость переключения, яркость пикселей 
void fun (int T1)
{
 v=1; Y2=millis();metka6:Y1=millis();if(Y1-Y2>=T1){} 
 else { x0=analogRead(A0); x1=analogRead(A1);n=map (x0,0,1023,15,150);k=map (x1,0,1023,5,100);if(digitalRead(7)==LOW&&v==1){N++;if (N==10){N=1;} Y3=millis();Y4=Y3;v=0;delay (200);} goto metka6;}

}

 ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

